import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class MultiComplexNewton extends Frame
{  public int Iter; public double Err;
   public MultiComplexNewton()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public Complex fn(Complex X)
   {  Complex X2 =X.mult(X); Complex X3 =X2.mult(X);
      return ((X3.add(X2.mult(2))).add(X)).add(1.0);  // X ^ 3 + X ^ 2 + X +1@ɉׂ
   }
   public Complex df(Complex X)
   {  Complex X2 =X.mult(X); 
      return ((X2.mult(3)).add(X.mult(4))).add(1.0);  // 3 X ^ 2 + 2 X +1@ɔ
   }
   public Complex updateDf(Complex[] Z, Complex DF, Complex F, Complex X, int K)
   {  Complex DFD, UDF; 
      if(K > 0) 
      {
         DFD = new Complex(0, 0); // F'-F*(1/(X-Zi))   (i=1`N-1)̌vZ
         for(int i = 0; i<= K-1; i++) DFD = DFD.add((X.sub(Z[i])).inv());
         UDF = DF.sub(F.mult(DFD));
      }
      else  UDF = DF;
      return UDF;
   }

   public Complex[] solution(int N, double EPS, double Xinit, int IterMax)
   { Complex [] Z = new Complex[3]; Complex  X, F, D; int k;
     int MI=0; double ME=0;
     for(k= 0; k< N;k++)
     { Iter = 0; X = new Complex(1, 1);
       while(Iter < IterMax)
       { Iter++; F=fn(X); Err = F.abs();if(Err < EPS) break;
         Complex DF = updateDf(Z, df(X), F, X, k);
         X = X.sub(F.div(DF));
        }
       Z[k] = X; if(Iter > MI) MI = Iter;
       if(Err  > ME) ME = Err;
     }
     Err = ME; Iter =MI;
     return Z;
   }
   public void paint(Graphics g)
   {  setTitle("fj[gEv\@"); Complex[] R = solution(3,0.0001, 1.0, 5000);
      g.drawString( "  (JԂ = "+ Iter + ", 덷 = " + Err +")" ,20,50);
      for(int i = 0; i < 3; i++)  g.drawString( " " + i + " : " + R[i] .ToString() ,20, 80 + i*20);
   } 
   public static void main(String[] args)
   {  Frame w = new MultiComplexNewton();
      w.setVisible(true);
   }
}
